from datetime import datetime
from typing import Optional

from flask import render_template, flash, Response, Blueprint, current_app
from flask.typing import ResponseReturnValue
from flask_wtf import FlaskForm
from sqlalchemy import exc
from wtforms import SubmitField, BooleanField

from app.extensions import db
from app.models.automation import Automation
from app.portal.util import view_lifecycle, response_404

bp = Blueprint("automation", __name__)


class EditAutomationForm(FlaskForm):  # type: ignore
    enabled = BooleanField('Enabled')
    submit = SubmitField('Save Changes')


@bp.route("/list")
def automation_list() -> ResponseReturnValue:
    automations = Automation.query.filter(
        Automation.destroyed.is_(None)).order_by(Automation.description).all()
    automations = list(filter(
        lambda a: a.short_name not in current_app.config.get('HIDDEN_AUTOMATIONS', []),
        automations
    ))
    return render_template("list.html.j2",
                           section="automation",
                           title="Automation Jobs",
                           item="automation",
                           items=automations)


@bp.route('/edit/<automation_id>', methods=['GET', 'POST'])
def automation_edit(automation_id: int) -> ResponseReturnValue:
    automation: Optional[Automation] = Automation.query.filter(Automation.id == automation_id).first()
    if automation is None:
        return Response(render_template("error.html.j2",
                                        section="automation",
                                        header="404 Automation Job Not Found",
                                        message="The requested automation job could not be found."),
                        status=404)
    form = EditAutomationForm(enabled=automation.enabled)
    if form.validate_on_submit():
        automation.enabled = form.enabled.data
        automation.updated = datetime.utcnow()
        try:
            db.session.commit()
            flash("Saved changes to bridge configuration.", "success")
        except exc.SQLAlchemyError:
            flash("An error occurred saving the changes to the bridge configuration.", "danger")
    return render_template("automation.html.j2",
                           section="automation",
                           automation=automation, form=form)


@bp.route("/kick/<automation_id>", methods=['GET', 'POST'])
def automation_kick(automation_id: int) -> ResponseReturnValue:
    automation = Automation.query.filter(
        Automation.id == automation_id,
        Automation.destroyed.is_(None)).first()
    if automation is None:
        return response_404("The requested bridge configuration could not be found.")
    return view_lifecycle(
        header="Kick automation timer?",
        message=automation.description,
        success_view="portal.automation.automation_list",
        success_message="This automation job will next run within 1 minute.",
        section="automation",
        resource=automation,
        action="kick"
    )
